!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module params

use inputs
use subrout
!USE nag_nlp
!USE nag_error_handling

implicit none

integer,parameter::npar=11, nstats=11

integer ageyoungest, notypes, year, years1, years2, size
parameter (notypes=10)
integer hoursdecision,quarter
double precision  propkid(notypes)
double precision chcostfunc1,chcostfunc2,chcostfunc3,chcostfunc4,chcostfunc5,chcostfunc6,chcostfunc7,chcostfunc8
double precision fedtax1, fedtax2, k1, k2, mhi, omega1, omega2, omega3, tax1, Emax, a0, a1, a0f, a1f, earntest, T1, T2



double precision,dimension(npar)::fpar,caliweig
integer:: imodel, icont, nmindex(3),sindex(3),nmindex2(4),sindex2(4),nmindexcl(6),sindexcl(6),nmindexcl2(7),sindexcl2(7)

double precision::modpars(npar), statdat(npar),guess(npar), parguess(npar),targetst(npar)



integer aggagemax, begnosims, bestiter, borrowdum, clage, fra, firstage, individ, husretage, lown, maxit, maxnod, & 
		maxntinp, method, na, noalpha, no, nt, ntmin, nq, nq2, nretage, ret, ntH, nssif, noparams,    &
		noexp, nonodes, nonodes2, nonodescl, nonodescl2, nosims, nw, olive, pnw,  totlen, uppn, &
        max_fun_eval, nc, wrunit

double precision aggrowth, alpha1, age1, age2, kidalpha, conbit, bitend, bitend2, bitwork, cpow,&
	 besterror,  chcostfunc(8), conk,  consprop, & 
childcost, bequest, corrho, deltaper0, deltaper1, deltatr, deltatr1, detrr, disc,  &
fullfrac, gendergap, growth, hours,  hoursfix, phoursfix,hourseis,  inithk, inilow, inihigh, iniggap, & 
invnu, kidalpha0, lowmult, highmult, kk, mm,  maxim,  minhours, &
meanwage, meanearn, meandisc, mediandelta, minass, mu, newchcostfunc(21), nokids, nu, nu1, &
oleta0,oleta1,oleta1i, page1, page2, partnomot, pvariance, ratiopartborn, simbit, & 
ssif(5), ssif62,ssif63,ssif64,ssif65,ssif66, trstd, xtol, upper, utpart,utpart2, utpart3, variance, &
propkid_1,propkid_2,propkid_3,propkid_4,propkid_5,propkid_6,propkid_7,propkid_8,propkid_9,propkid_10,  &
chi,chi1,phi,phi1,theta,theta1,alfa,alfa1,alfa11,&
coef0, coefchild1, coefchild2, coefchild3, coefsize, coefage1, coefage2, coefage3, coefage1h, coefage2h, coefage3h,&
survpen(5),survpen62, survpen63,survpen64, survpen65,survpen66,pdeath65(2), pdeath66(2), pdeath67(2), pdeath68(2), pdeath69(2), pdeath70(2), pdeath71(2), pdeath72(2), pdeath73(2), pdeath74(2), pdeath75(2), &
&pdeath76(2), pdeath77(2), pdeath78(2),pdeath79(2), pdeath80(2), pdeath81(2), pdeath82(2), pdeath83(2), pdeath84(2), pdeath85(2), &
pdeath86(2), pdeath87(2), pdeath88(2), pdeath89(2), pdeath90(2), f65, f64, f63, f62, premia

double precision datanokids, datapart, datapartkids, datapartkids1, datapartkids2, datamediandelta, dataggap, & 
        dataoleta1, dataoleta2, data3to18, datahours, eps,eps1


character*80 dummyinp

integer agekid, agekid2, indic, frischt, output, solut, weignosims

double precision:: wagevar

double precision, allocatable :: ahigh(:), ahigh2(:), alow(:,:), asscut(:, :), asscutcl(:, :), mininc(:,:)                    
double precision, allocatable :: xanon(:,:,:),xawork(:,:,:), xaret(:,:,:),xanoncl(:,:,:),xaworkcl(:,:,:)
double precision, allocatable :: valemploy(:,:), valun(:,:),valr(:,:),valrW(:,:),valrWh(:,:),valo(:,:)  
double precision, allocatable :: valemploycl(:,:), valuncl(:,:)  
double precision, allocatable :: withemploy(:,:), withun(:,:)
double precision, allocatable :: withemploycl(:,:), withuncl(:,:) 
double precision, allocatable :: withr(:,:),withrW(:,:), withrWh(:,:)
integer, allocatable :: dec(:,:),decsav(:,:),decemp(:,:)
double precision, allocatable :: infants(:), fixed(:), equival(:,:), pdeath1(:), pdeath2(:), psurv1(:),psurv2(:)
double precision, allocatable :: calibstats(:), calibparams(:)
double precision, allocatable :: randnos1(:), randexp(:), randupdate(:), prob(:,:,:,:,:), pxw3(:,:),pxw(:,:), &
&pxw2(:,:), xww(:,:),probF(:,:,:),xpen(:), xpenlong(:,:,:,:),pialong(:,:,:,:), pxpen(:)
double precision, allocatable :: maxpartcash(:)

double precision, parameter		:: pi = 3.141592653589793d0 

integer, parameter						:: nostat = 2
integer, private							:: i, t

integer, allocatable :: visitemp(:,:), visitnon(:,:), visitexpvalue (:,:)

integer, allocatable :: numsimsurv(:)

character*7::namest(nstats),namepar(npar)

contains




subroutine reading1

	implicit none
	integer	:: ier(2)

	open (unit=9, file='../Inteninps/mpiparams.inp', status='old', err=900)
		read (9,*) quarter
	    read (9,*) nt		!1				number of MAX periods of work
		read (9,*) ntmin		!1		 number of MIN periods of work
 	    read (9,*) ret		!2				number of periods of retirement
		read (9,*) ntH      !number of periods work husband
	    read (9,*) na		!3				number of grid points in (conditional) cash-in-hand state
	    read (9,*) nw		!5
	    read (9,*) noexp	!6       max number of years experience
		read (9,*) nq
		read (9,*) nq2
	    read (9,*) lown		!7			used in making cash grid finer at low cash levels
	    read (9,*) uppn		!8			used in making cash grid more coarse at high cash levels
	    read (9,*) maxit	!9			number of iterations in trying to solve
	    read (9,*) pnw		!11
	    read (9,*) nosims	!15			total number of simulations = nosims
	    read (9,*) minass 		!8		(machine zero issue)
	    read (9,*) xtol   		!9    (machine zero issue)
	    read (9,*) maxim  		!10		defining upper bound on cash grid
	    read (9,*) growth 		!11   defining upper bound on cash grid
	    read (9,*) upper  		!12 upper will be chosen by the resass number
	    read (9,*) nu    	!1	risk aversion
	    read (9,*) detrr    	!4	constant interest rate 
	    read (9,*) meandisc 	!5	constant discount rate
	    read (9,*) age1        	!13 wage growth
	    read (9,*) age2        	!14 wage growth
	    read (9,*) variance		!15 variance of permanent productivity shock
	    read (9,*) pvariance   	!18 variance of primary earner perm prod shocks
	    read (9,*) corrho       ! correlation coefficient bet permanent shocks
	    read (9,*) meanwage		!23 mean wage for second earner
	    read (9,*) meanearn		!24 mean earnings for husband
	    read (9,*) page1		!25 earnings growth for husband
	    read (9,*) page2		!26										 
	    read (9,*) inithk			!35
		read (9,*) hours    	!3	total hours available each period
	    read (9,*) phoursfix			!38
		read (9,*) hoursfix			!38
		read (9,*) minhours
	    read (9,*) nokids			!44
	    read (9,*) propkid_1
	    read (9,*) propkid_2
	    read (9,*) propkid_3
	    read (9,*) propkid_4
	    read (9,*) propkid_5
	    read (9,*) propkid_6
	    read (9,*) propkid_7
	    read (9,*) propkid_8
	    read (9,*) propkid_9
	    read (9,*) propkid_10
	    read (9,*) mm
	    read (9,*) fullfrac
        read (9,*) olive
	    read (9,*) chcostfunc1
	    read (9,*) chcostfunc2
	    read (9,*) chcostfunc3
	    read (9,*) chcostfunc4
	    read (9,*) chcostfunc5
	    read (9,*) chcostfunc6
	    read (9,*) chcostfunc7
	    read (9,*) chcostfunc8
        read (9,*) borrowdum
	    read (9,*) fra
		read (9,*) f65
		read (9,*) f64
		read (9,*) f63
		read (9,*) f62
		read (9,*) premia
		read (9,*) nc
		read (9,*) ssif66
		read (9,*) ssif65
		read (9,*) ssif64
		read (9,*) ssif63
		read (9,*) ssif62
		read (9,*) survpen66
		read (9,*) survpen65
		read (9,*) survpen64
		read (9,*) survpen63
		read (9,*) survpen62
		read (9,*) k1
		read (9,*) k2
		read (9,*) omega1
		read (9,*) omega2
		read (9,*) omega3
		read (9,*) tax1
		read (9,*) mhi
		read (9,*) fedtax1
		read (9,*) fedtax2
		read (9,*) Emax
		read (9,*) earntest
		read (9,*) T1
		read (9,*) T2
		read (9,*) pdeath66
		read (9,*) pdeath67
		read (9,*) pdeath68
		read (9,*) pdeath69
		read (9,*) pdeath70
		read (9,*) pdeath71
		read (9,*) pdeath72
		read (9,*) pdeath73
		read (9,*) pdeath74
		read (9,*) pdeath75
		read (9,*) pdeath76
		read (9,*) pdeath77
		read (9,*) pdeath78
		read (9,*) pdeath79
		read (9,*) pdeath80
		read (9,*) pdeath81
		read (9,*) pdeath82
		read (9,*) pdeath83
		read (9,*) pdeath84
		read (9,*) pdeath85
		read (9,*) pdeath86
		read (9,*) pdeath87
		read (9,*) pdeath88
		read (9,*) pdeath89
		read (9,*) pdeath90
		read (9,*) a0
		read (9,*) a1
		read (9,*) a0f
		read (9,*) a1f
		
        								
	close (9) 
	
	disc     = 1.d0 / meandisc
	
	

	
	
	hourseis   = hours - hoursfix


	open (unit=9, file='../Inteninps/targets.inp', status='old', err=900)

        read (9,*) datanokids
        read (9,*) datapart			
        read (9,*) datapartkids		
        read (9,*) datamediandelta
        read (9,*) dataggap
        read (9,*) dataoleta1
        read (9,*) dataoleta2
        read (9,*) data3to18
        read (9,*) datapartkids1 
        read (9,*) datapartkids2
        read (9,*) datahours

    close (9) 
    
    open (unit=19, file='../Inteninps/coef.inp', status='old', err=900)

        read (19,*) coef0
        read (19,*) coefage1
        read (19,*) coefage2
        read (19,*) coefage3
        read (19,*) coefchild1
        read (19,*) coefchild2
        read (19,*) coefchild3
        read (19,*) coefsize 

    close (19) 
    
    

 900     continue
!		write (*,*) 'error opening params.inp '


end subroutine reading1
	
subroutine reading2( iret )
	
	implicit none
	integer, intent(out)	:: iret
	integer	:: ier(2)

	
	
	maxntinp    = nt
	no			= 1
	totlen		= maxntinp + ret
	
    nretage = 1 !nt - ntmin + 1 !all claim at 62
	
	nssif = ntH+1-ntmin
	
	clage = 1
	
	nonodes		= pnw*na*nw*noexp
	nonodes2    = pnw*nw*noexp
            
    nmindex = (/nw,pnw,noexp/)
    nmindex2 = (/nw,pnw,noexp,na/)
	
	
	nonodescl		= pnw*na*nw*noexp*1*nq2*nq
	nonodescl2      = pnw*nw*noexp*1*nq2*nq

	nmindexcl = (/nw,pnw,noexp,1,nq2,nq/)
    nmindexcl2 = (/nw,pnw,noexp,1,nq2,nq,na/)

     eps = 0.99d0 
     eps1 = 1.01d0

     
	!ALLOCATE ARRAYS

	allocate ( ahigh(totlen), ahigh2(totlen), alow(noexp,totlen), asscut(nonodes2,totlen), maxpartcash(totlen),	&
		    xanon(na,nonodes2,totlen), xawork(na,nonodes2,totlen), xaret(na,nonodes2,totlen), &
			valemploy(nonodes,totlen), valun(nonodes,totlen), &
			valr(nonodes,totlen),valrW(nonodes,totlen), valrWh(nonodes,totlen), &
			withemploy(nonodes,totlen), withun(nonodes,totlen), &
			withr(nonodes,totlen),withrW(nonodes,totlen), withrWh(nonodes,totlen),mininc(noexp,totlen), &
			equival(totlen,3), infants(totlen), fixed(maxntinp), &
            calibparams(npar), calibstats(npar),  & 
			pdeath1(ret), pdeath2(ret), psurv1(ret), psurv2(ret),  & 
			stat = ier(1) )
			
	allocate( asscutcl(nonodescl2,nt-ntmin), xanoncl(na,nonodescl2,nt-ntmin),xaworkcl(na,nonodescl2,nt-ntmin),&
			valemploycl(nonodescl,nt-ntmin), valuncl(nonodescl,nt-ntmin), &
			withemploycl(nonodescl,nt-ntmin), withuncl(nonodescl,nt-ntmin), stat = ier(1) )
			
			
	!allocate(valo(nonodes,nt-ntmin),dec(nonodes,nt-ntmin),decsav(nonodes,nt-ntmin),decemp(nonodes,nt-ntmin),stat = ier(1) )

	allocate ( visitnon(totlen,na), visitemp(totlen,na), visitexpvalue(totlen,noexp),  &  
            numsimsurv(ret), 	stat = ier(2) )

	do i=1,2
		if ( ier(i).ne.0) then 
			iret = ier(i)
			return
		endif
	enddo

	iret = 0

	return

171 format (a80)

!900 continue
!		write (*,*) 'error opening params.inp '
		return

end subroutine reading2




subroutine modpar


        hoursdecision=0
		
		
		
		
		
		pdeath1=(/pdeath66(1), pdeath67(1), pdeath68(1), pdeath69(1), pdeath70(1), pdeath71(1), pdeath72(1), pdeath73(1), pdeath74(1), pdeath75(1),&
		&pdeath76(1), pdeath77(1), pdeath78(1),pdeath79(1),pdeath80(1), pdeath81(1), pdeath82(1), pdeath83(1), pdeath84(1), pdeath85(1),&
		pdeath86(1), pdeath87(1), pdeath88(1), pdeath89(1),pdeath90(1)/)
		
		
	    pdeath2=(/pdeath66(2), pdeath67(2), pdeath68(2), pdeath69(2), pdeath70(2), pdeath71(2), pdeath72(2), pdeath73(2), pdeath74(2), pdeath75(2),&
		&pdeath76(2), pdeath77(2), pdeath78(2),pdeath79(2),pdeath80(2), pdeath81(2), pdeath82(2), pdeath83(2), pdeath84(2), pdeath85(2),&
		pdeath86(2), pdeath87(2), pdeath88(2), pdeath89(2), pdeath90(2)/)
        
		
		psurv1=1.d0-pdeath1
		psurv2=1.d0-pdeath2
		
	
		
		nu1=1.d0-nu
		
		
		agekid2=agekid  + (1-quarter)*3 + quarter*12  !second child
		
		!cost of children if working
		infants=0.d0
		
			
		newchcostfunc=(/0.5d0,0.5d0,0.5d0,1.d0,0.9d0,0.6d0,0.6d0,0.5d0,0.2d0,0.2d0,0.2d0,0.2d0,0.2d0,0.2d0,0.2d0,0.1d0,0.1d0,0.1d0,0.d0,0.d0,0.d0/)
		
		
		
		ssif     =(/ssif62, ssif63, ssif64, ssif65, ssif66/)
		survpen  =(/survpen62, survpen63, survpen64, survpen65, survpen66/)
		
		!if(ID.eq.0)write(*,*)'ssif,survpen',ssif,survpen
		
		
		do t=1,totlen
		    if(quarter.eq.0)then
		        year=t               !age of hhold 
		        
		        years1=t-agekid   !age of first child
		        years2=t-agekid2  !age of second child
		  
		    else
		        year=(t-1)/4 + 1
		        years1=(t-1)/4  - (agekid-1)/4 
                years2=(t-1)/4  - (agekid2-1)/4 
		    endif

		    
	
            
           !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            !ALTERNATIVE 1
            !cost of children using Orazio estimates, see 
            !C:\PROYECTOS_INACTIVOS\WOM-US\datos\orazio data childcare\ChildCareCostFunctionCEX.txt
            !if (t.ge.agekid.AND.t.le.agekid+(1-quarter)*7+quarter*28)then         
	        !   infants(t) = kidalpha0*chcostfunc(years1 + 1 )/chcostfunc(1)   
	        !endif
            
            !ALTERNATIVE 2: follow cost NACCRA
            !1-we assume positive child care cost from age 0 to 4
            !2-we assume child care cost is twice when second child arrives
            
            
            if(t.ge.agekid.AND.t.le.agekid+20)then
                infants(t) = kidalpha0*newchcostfunc(t-agekid + 1)    
            
			!if(ID.eq.0)write(*,*)t, agekid,infants(t)
			endif

		
			
		   !equivalences of scale
		   equival(t,1:3)=1.d0
		   !widow hhold
		   equival(t,2:3) =1.d0
		   
!		   !two-adult hholds
			equival(t,1) = 1.67d0
			
			!first child
			if (t.lt.agekid) then 
				equival(t,1) = equival(t,1) 
			elseif (t-agekid.le.(1-quarter)*3+quarter*12) then
				equival(t,1) = equival(t,1) + 0.233d0
			elseif (t-agekid.le.(1-quarter)*7+quarter*28) then 
				equival(t,1) = equival(t,1) + 0.33d0
			elseif (t-agekid.le.(1-quarter)*12+quarter*48) then 
				equival(t,1) = equival(t,1) + 0.4d0
			elseif (t-agekid.le.(1-quarter)*18+quarter*72) then
				equival(t,1) = equival(t,1) + 0.533d0
			endif

			!second child
			if (t.lt.agekid2) then 
				equival(t,1) = equival(t,1) 
			elseif (t-agekid2.le.(1-quarter)*3+quarter*12) then
				equival(t,1) = equival(t,1) + 0.233d0
			elseif (t-agekid2.le.(1-quarter)*7+quarter*28) then 
				equival(t,1) = equival(t,1) + 0.33d0
			elseif (t-agekid2.le.(1-quarter)*12+quarter*48) then 
				equival(t,1) = equival(t,1) + 0.4d0
			elseif (t-agekid2.le.(1-quarter)*18+quarter*72) then
				equival(t,1) = equival(t,1) + 0.533d0
			endif

			

			
		enddo  !t
		
	!equival=1.d0


!if(ID.eq.0)write(*,*)infants		
		
		
		
        statdat(1)= datanokids  
        statdat(2)= datapart
        statdat(3)= datapartkids
		statdat(4)= datamediandelta
        statdat(5)= dataggap
        statdat(6)= dataoleta1
        statdat(7)= dataoleta2
        statdat(8)= data3to18
        statdat(9)= datapartkids1
        statdat(10)= datapartkids2
        statdat(11)= datahours
        
		
end subroutine modpar
!______________________________________________
double precision function utility(cons, leis, age, hhold)
	 
		double precision cons, leis, conse, uconse
		integer age, hhold
		
		
		conse=cons/equival(age,hhold)
		
		if(nu.lt.1.01d0)then  !log utility
			if(hhold.eq.1)then
				uconse=2.d0*log(conse)
			else
				uconse=log(conse)
			endif       
		else	                  !CES utility 
			uconse=conse**(1.d0-nu)/(1.d0-nu)
		endif
		
		
		
		

		if (leis.lt.hours) then 
		
			
			if(age.ge.31)then  !starting at 55
			!if(age.ge.ntmin)then !starting at early retirement age
				
				if(age.gt.ntH)then !husband already retired (capture complementary of leisure)
					utility = uconse - utpart2*((real(age)/31.d0)**utpart) -utpart3
				else   !husband still at work
					utility = uconse - utpart2*((real(age)/31.d0)**utpart)
				endif
			else
				utility = uconse - utpart2
			endif
			
			
		else
				
			utility = uconse
				
			
		endif 
		
		
		
end function utility
!______________________________________________
double precision function margutc(cons, leis, age, hhold)
	 
		double precision cons, leis, aux, aux1, alfa2, conse
		integer age, stat, hhold
		
		conse=cons/equival(age, hhold)
		
		if(leis.lt.hours)then
		    stat=1
		else
		    stat=0
		endif
		
		  
			    if (stat==1) then 
					margutc = (equival(age,hhold)/cons)**(nu) / equival(age, hhold)  
				else
					margutc = (equival(age,hhold)/cons)**(nu) / equival(age, hhold) 
				endif
		
		
end function margutc



!______________________________________________
subroutine find(fage, fass, fnodeas, fmina, faet,fxet,stat)

	integer fage, fmina, fnodeas, jl, jm, ju , stat
	double precision atmin, atmax, atdiff, fass, faet, fxet, inteta

		   if (stat.eq.1) then 
			
			  jl=0
			  ju=na+1
812			  if (ju-jl.gt.1) then
				jm = (ju+jl)/2
				if (fass.gt.xawork(jm,fnodeas,fage) ) then
					jl = jm
				else
					ju = jm
				endif
				goto 812
			  endif
			  fmina = jl
			  if (fmina.eq.na) then
				fmina = na-1
			  elseif (fmina.eq.0) then
                fmina = 1
			  endif
  
			  atmin  = xawork(fmina,fnodeas, fage)       
			  atmax  = xawork(fmina+1,fnodeas, fage)       
			  atdiff = atmax - atmin  
			
			elseif (stat.eq.2) then 
			
			  jl=0
			  ju=na+1
813			  if (ju-jl.gt.1) then
				jm = (ju+jl)/2
				if (fass.gt.xaret(jm,fnodeas,fage) ) then
					jl = jm
				else
					ju = jm
				endif
				goto 813
			  endif
			  fmina = jl
			  if (fmina.eq.na) then
				fmina = na-1
			  elseif (fmina.eq.0) then
                fmina = 1
			  endif
  
			  atmin  = xaret(fmina,fnodeas, fage)       
			  atmax  = xaret(fmina+1,fnodeas, fage)       
			  atdiff = atmax - atmin  

		
		   else 
			
			  jl=0
			  ju=na+1
814			  if (ju-jl.gt.1) then
				jm = (ju+jl)/2
				if (fass.gt.xanon(jm,fnodeas,fage) ) then
				
					jl = jm
				else
					ju = jm
				endif
				goto 814
			  endif
			  fmina = jl
			  if (fmina.eq.na) then
				fmina = na-1
			  elseif (fmina.eq.0) then
                fmina = 1
			  endif
  
			  atmin  = xanon(fmina,fnodeas, fage)       
			  atmax  = xanon(fmina+1,fnodeas, fage)       

			  

			  atdiff = atmax - atmin  

	
		   endif


			  inteta = (2.d0*fass -atmax - atmin)/ atdiff          
			  faet = 0.5d0*(1.d0-inteta          )
			  fxet = 0.5d0*(1.d0+inteta          )

end subroutine find



!______________________________________________
subroutine findcl(fage, fass, fnodeas, fmina, faet,fxet,stat)

	integer fage, fmina, fnodeas, jl, jm, ju , stat
	double precision atmin, atmax, atdiff, fass, faet, fxet, inteta

		   if (stat.eq.1) then 
			
			  jl=0
			  ju=na+1
812			  if (ju-jl.gt.1) then
				jm = (ju+jl)/2
				if (fass.gt.xaworkcl(jm,fnodeas,fage-ntmin) ) then
					jl = jm
				else
					ju = jm
				endif
				goto 812
			  endif
			  fmina = jl
			  if (fmina.eq.na) then
				fmina = na-1
			  elseif (fmina.eq.0) then
                fmina = 1
			  endif
  
			  atmin  = xaworkcl(fmina,fnodeas, fage-ntmin)       
			  atmax  = xaworkcl(fmina+1,fnodeas, fage-ntmin)       
			  atdiff = atmax - atmin  
			
			
		   else 
			
			  jl=0
			  ju=na+1
814			  if (ju-jl.gt.1) then
				jm = (ju+jl)/2
				if (fass.gt.xanoncl(jm,fnodeas,fage-ntmin) ) then
				
					jl = jm
				else
					ju = jm
				endif
				goto 814
			  endif
			  fmina = jl
			  if (fmina.eq.na) then
				fmina = na-1
			  elseif (fmina.eq.0) then
                fmina = 1
			  endif
  
			  atmin  = xanoncl(fmina,fnodeas, fage-ntmin)       
			  atmax  = xanoncl(fmina+1,fnodeas, fage-ntmin)       

			  

			  atdiff = atmax - atmin  

	
		   endif


			  inteta = (2.d0*fass -atmax - atmin)/ atdiff          
			  faet = 0.5d0*(1.d0-inteta          )
			  fxet = 0.5d0*(1.d0+inteta          )

end subroutine findcl
!______________________________________________
double precision function deltaperF(humcap)
double precision humcap

    if (humcap.le.1.d0) then 
        deltaperF = 0.d0 ! deltaper0
    else
        !deltaperF = deltaper1 * humcap
        deltaperF = deltaper1 
    endif

!to have the same lower bounds for the human capital for both
!maternity groups
if (humcap*(1.d0 - deltaperF).lt.1.d0) then
        deltaperF = (humcap - 1.d0) / humcap
endif

end function deltaperF



!______________________________________________

double precision function pensionHUS(pia)
double precision pia, retage


if (pia.lt.k1) then
	pensionHUS=omega1*pia
elseif (pia.ge.k1.AND.pia.lt.k2) then
	pensionHUS=omega1*k1 + omega2*(pia-k1)	
else
    pensionHUS=omega1*k1 + omega2*(k2-k1) + omega3*(min(pia,Emax)-k2) 
endif

retage= ntH + 25

if(retage.eq.65)pensionHUS=pensionHUS*f65
if(retage.eq.64)pensionHUS=pensionHUS*f64
if(retage.eq.63)pensionHUS=pensionHUS*f63
if(retage.eq.62)pensionHUS=pensionHUS*f62

!if(ID.eq.0)write(*,*)ntH,retage,pensionHUS,f62

end function pensionHUS


!______________________________________________

double precision function pension(pia,c)
double precision pia
integer retage, c

retage= ntmin + (c-1) + 25


if (pia.lt.k1) then
	pension=omega1*pia
elseif (pia.ge.k1.AND.pia.lt.k2) then
	pension=omega1*k1 + omega2*(pia-k1)	
else
    pension=omega1*k1 + omega2*(k2-k1) + omega3*(min(pia,Emax)-k2) 
endif


if(retage.eq.62)pension=pension*f62
if(retage.eq.63)pension=pension*f63
if(retage.eq.64)pension=pension*f64
if(retage.eq.65)pension=pension*f65
if(retage.gt.fra)pension=pension*(1.d0 + premia*real(retage-fra))


end function pension



!______________________________________________
double precision function payrolltax(earn)
double precision earn


    payrolltax =tax1*min(earn,Emax) 

end function payrolltax




!______________________________________________
double precision function federaltax(earnm,earnf,federaltaxhusband,penf)
double precision earnf,earnm,totinc, ratio, avfederaltax, federaltaxhusband,penf,ssinc,provinc,taxable

!HERE WE CALCULATE """""ADDITIONAL""""" TAXES THAT THE HOUSEHOLD WOULD PAY IF THE WIFE WORKS
!earnm:=husband earnings if age<=ntH and husband benefit otherwise
!federaltaxhusband:taxes paid if the women does not work

if(age.lt.ntmin)then !both husband and wife are working and there is not social security income

	totinc=earnf + earnm 
	

else  !wife receives ss benefits

	if(age.le.ntH)then  !husband only receives earnings
		ssinc=penf
		provinc=earnm + earnf + 0.5d0*ssinc
		totinc=earnm + earnf


	else   !husband only receives ss benefits, wife may receive earnings or not
		ssinc=penf + earnm
		provinc= earnf + 0.5d0*ssinc
		totinc=earnf

	endif
	
	
	if(provinc.le.T1)then
		taxable=0.d0
	elseif(provinc.gt.T1.and.provinc.le.T2)then
		taxable=min(0.5d0*ssinc, 0.5d0*(provinc-T1))
	else
		taxable= min(0.85d0*ssinc, 0.85d0*(provinc-T2) + min(0.5d0*ssinc, 0.5d0*(T2-T1)) )
	endif
	
	totinc= totinc + taxable

endif



ratio=totinc/mhi 
avfederaltax = fedtax1+ fedtax2*log(ratio)
federaltax=max(avfederaltax*totinc - federaltaxhusband,0.d0)

end function federaltax

!______________________________________________
double precision function federaltaxm(earnm,penf)

!HERE CALCULATE TAXES THAT THE HOUSEHOLD WOULD PAY IF THE
!WIFE DOES NOT WORK

!earnm:=husband earnings if age<=ntH and husband benefit otherwise
double precision earnm,totinc, ratio, avfederaltax,penf,ssinc,provinc,taxable


if(age.lt.ntmin)then !both husband and wife are working and there is not social security income

	totinc=earnm 
	

else  !wife receives ss benefits

	if(age.le.ntH)then  !husband only receives earnings
		ssinc=penf
		provinc=earnm + 0.5d0*ssinc
		totinc=earnm 


	else   !husband only receives ss benefits
		ssinc=penf + earnm
		provinc= 0.5d0*ssinc
		totinc=0.d0

	endif
	
	
	if(provinc.le.T1)then
		taxable=0.d0
	elseif(provinc.gt.T1.and.provinc.le.T2)then
		taxable=min(0.5d0*ssinc, 0.5d0*(provinc-T1))
	else
		taxable= min(0.85d0*ssinc, 0.85d0*(provinc-T2) + min(0.5d0*ssinc, 0.5d0*(T2-T1)) )
	endif
	
	totinc= totinc + taxable

endif

ratio=totinc/mhi
avfederaltax = fedtax1 + fedtax2*log(ratio)
federaltaxm=max(avfederaltax*totinc,0.d0)

end function federaltaxm





!______________________________________________
subroutine findpension(pen, fmina, faet,fxet)

	integer fmina, jl, jm, ju 
	double precision atmin, atmax, atdiff, pen, faet, fxet, inteta

	!ojo: a diferencia del partcash que va de menor  mayor, la xpen va de mayor a menor!!!
	
	if(nw.gt.1)then
		if(pen.lt.1.d0)then
		
				fmina =nw
				faet =0.d0
				fxet =1.d0
		else
				
				  jl=0
				  ju=nw+1
	812			  if (ju-jl.gt.1) then
					jm = (ju+jl)/2
					if (pen.gt.xpen(jm) ) then
						!jl = jm
						ju = jm
					else
						!ju = jm
						jl = jm
					endif
					goto 812
				  endif
				  fmina = jl
				  if (fmina.eq.nw) then
					fmina = nw-1
				  elseif (fmina.eq.0) then
					fmina = 1
				  endif
	  
				  atmin  = xpen(fmina)       
				  atmax  = xpen(fmina+1)       
				  atdiff = atmax - atmin  
				

				  inteta = (2.d0*pen -atmax - atmin)/ atdiff          
				  faet = 0.5d0*(1.d0-inteta          )
				  fxet = 0.5d0*(1.d0+inteta          )
				  
				  
				  !16/7/2015:puesto que no hago interpolacin voy a asignarle el punto del grid que tiene mas cerca
				  if(fxet>0.5d0)then
					fmina = min(fmina + 1,nw)
				  endif
		endif
	else
		fmina=1
	endif

end subroutine findpension

end module params

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
