clear
capture log close


log using sampleMERGE-R1.log,replace
u sample

rename stat statB
rename couple coupleB
rename retage retageB
rename experien experienB
rename saving savingB
rename partcash partchasB
rename wagef wagefB
rename piaf piafB 
rename pf pfB
rename socsecf socsecfB
rename penf penfB
rename tipoMARR tipoMARRB
rename tipoWID tipoWIDB
rename ageret ageretB


by i:egen typeMARRB=min(tipoMARRB)
by i:egen typeWIDB=min(tipoWIDB)

merge 1:1 i t using sampleR1

table age if typeMARRB==1,c(mean statB mean stat mean experienB mean experien)
table age if typeMARRB>1,c(mean statB mean stat mean experienB mean experien)

/*
COMMENTS:
1-women who were eligible as workers in the baseline have almost same participation profile. It is only slighly above what
is related with the uncertainty in labor earnings

2-women who were eligible as workers+spousal or spousal in the baseline increase their participation substaintially.
In particular we observe they increase their participation in order to qualify for a public pension, so that they complete
the 10 years of work experience that are required. Maybe the effects would be smoother if there was a pure proportional 
benefit.


*/
log close


*fin