!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine calibrate
use inputs
use statistics
use params
implicit none
double precision::  rannum, time1, time2, lectura(5) !,guess(numtargets)

INTEGER::cont,var(numtargets),randier, ii, jj1, w, p, ww, pp, t

character*1::num1,num2,num3,num4
character*4::name1,name7
character*6::name2
character*40::name11
character*42::name21
character*28::path

external partner

open (unit=10,  file ='../Outputs/dump.out')             
open (unit=12, RECL=2000,file ='../Outputs/dump2.out')             


!1--------READ PARAMETER VALUES TO NODE 1 AND BROADCAST TO THE OTHER NODES
if (id==0) then
	call reading1
endif

 
call MPI_BCAST(quarter,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nt,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ntmin,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ret,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ntH,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(na,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nw,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(noexp,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nq,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nq2,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(lown,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(uppn,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(maxit,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pnw,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nosims,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(minass,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(xtol,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(maxim,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(growth,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(upper,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nu,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(detrr,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meandisc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(disc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(age1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(age2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(variance,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pvariance,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(corrho,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meanwage,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meanearn,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(page1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(page2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(inithk,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(hours,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(phoursfix,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(hoursfix,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(minhours,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
!call MPI_BCAST(maxhourspart,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
!call MPI_BCAST(minhoursfull,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
!call MPI_BCAST(maxhoursfull,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nokids,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(propkid_1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_5,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_6,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_7,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_8,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_9,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_10,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(mm,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(fullfrac,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(olive,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc5,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc6,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc7,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc8,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
!call MPI_BCAST(startobs,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
!call MPI_BCAST(endobs,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
!call MPI_BCAST(tobs,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(borrowdum,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(fra,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(f65,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(f64,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(f63,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(f62,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(premia,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nc,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ssif66,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ssif65,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ssif64,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ssif63,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ssif62,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(survpen66,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(survpen65,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(survpen64,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(survpen63,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(survpen62,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(k1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(k2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(omega1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(omega2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(omega3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(tax1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(mhi,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(fedtax1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(fedtax2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(Emax,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(earntest,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(T1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(T2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(pdeath65,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath66,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath67,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath68,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath69,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath70,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath71,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath72,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath73,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath74,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath75,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath76,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath77,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath78,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath79,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath80,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath81,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath82,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath83,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pdeath84,3,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)



call MPI_BCAST(a0,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(a1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(a0f,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(a1f,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


call MPI_BCAST(datanokids,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapart,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapartkids1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datamediandelta,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataggap,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataoleta1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataoleta2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapartkids2 ,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


call MPI_BCAST(coef0,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage1h,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage2h,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage3h,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefsize,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(hourseis,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


propkid=(/propkid_1,propkid_2,propkid_3,propkid_4,propkid_5,propkid_6,propkid_7,propkid_8,propkid_9,propkid_10/)
chcostfunc=(/chcostfunc1,chcostfunc2,chcostfunc3,chcostfunc4,chcostfunc5,chcostfunc6,chcostfunc7,chcostfunc8/)


!2--------READ GUESS FOR PARAMETER VALUES TO NODE 1 AND BROADCAST TO THE OTHER NODES
if(id==0)then
	open(unit=999, file ='../Inteninps/mpiguess.inp')  
	do cont=1,numtargets
		read (999,*) guess(cont)
		
	enddo
	close(999)
endif


if(ID==0)write(*,*)numtargets
do cont=1,numtargets
	call MPI_BCAST(guess(cont),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
	if(ID==0)write(*,*)cont,guess(cont)
enddo

!3 --------- Read in randnos and broadcast to to all
!   first allocate memory to store random numbers
allocate (randnos1(nt*nosims), randexp(nt*nosims), randupdate(ret*nosims), stat=randier)
if (randier.ne.0) write (*,*) 'error in allocating to randnos '

        open (unit=77, file ='../Inteninps/randnos.inp')   !for wages and earnings shocks
        !file randnos.inp contains nt*nosims*5 random numbers
                                               
        do ii=1,nosims*nt-4,5
            read (77,9299) (randnos1(ii+jj1),jj1=0,4)
        enddo
		read (77,9299) lectura
		randnos1(ii:ii+1)=lectura(1:2)
		
        do ii=nosims*nt+1,nosims*nt*2-4,5
            read (77,9299) (randexp(ii+jj1-nosims*nt),jj1=0,4)
        enddo
		read (77,9299) lectura
		randexp(ii:ii+1-nosims*nt)=lectura(1:2)
		
        close(77)
    
        open(unit=777, file ='../Inteninps/randnosupdate.inp')  !for survival probabiliteis
        do ii=1,nosims*ret
            read(777,*)randupdate(ii)
        enddo
	
	9299 format (5E16.8)	 



!4 --------- Read in wages and broadcast to to all

allocate(prob(nw,pnw,nw,pnw,nt),xww(nw,nt), pxw2(pnw,nt), pxw3(pnw,nt),pxw(pnw,nt),probF(nw,nw,nt), stat=randier)


if (randier.ne.0) write (*,*) 'error in allocating to wages '




if(nw.gt.1)then

    open(333,file='../Inteninps/wagepoints1812p_f_s3.inp')
    open(335,file='../Inteninps/wagepoints1812p_m_s3.inp')
    do w=1,pnw
    do t=1,nt
	    read(335,3346)pxw2(w,t)
	   
    enddo;enddo
    
    do w=1,nw
    do t=1,nt
	    read(333,3346)xww(w,t)
	    
    enddo;enddo
    
    close(333)
    close(335)


3346 format (e17.8)






	open(334,file='../Inteninps/transwagepoints1812p_s3.inp')

	do t=1,nt
	do w=1,nw
	do p=1,pnw
	do ww=1,nw
	do pp=1,pnw
		read(334,3349)prob(ww,pp,w,p,t)
	enddo;enddo;enddo;enddo;enddo
	close(334)
3349 format (e17.8)

endif




cont=0
do j_grid=1,1 !18,98,40   !loop for period in which wage is increased, !1,1 for the baseline
    
      cont=cont+1
      if (cont.eq.1) then 
        firstcall = 1
      else
        firstcall = 0
      endif


ingrid2=1 !2  !equal 1 if calibrating
ngrid2 =1 !4  !equal 1 if calibrating

do j_grid2=ingrid2,ngrid2    !loop for the size of the variation in wage
      
        wagevar=1.d0
        frischt=0
         
        if(j_grid2==2)wagevar=1.01d0
        if(j_grid2==3)wagevar=1.05d0
        if(j_grid2==4)wagevar=1.10d0
        
       
        frischt = j_grid-1 
        
        
        
 
        if (id==0) then
                 
			
			open(unit=20, file ='../Outputs/sims.out')
            open(unit=44, file ='../Outputs/sample.out')  
            open(unit=1111, file ='../Outputs/gridsearch.out') 
            
        endif

   
	
	    PARGUESS(1)=guess(1) 
		PARGUESS(2)=guess(2) 
		PARGUESS(3)=guess(3) 
		PARGUESS(4)=guess(4) 
		PARGUESS(5)=guess(5) 
		PARGUESS(6)=guess(6) 
		PARGUESS(7)=guess(7) 
		PARGUESS(8)=guess(8) 
		PARGUESS(9)=guess(9) 
        PARGUESS(10)=guess(10)
	    PARGUESS(11)=guess(11)
	    


        if(j_grid==1)then     

        elseif(j_grid==2)then
         
PARGUESS(5)=22000.d0

	
        elseif(j_grid==3)then
PARGUESS(5)=22500.d0



        elseif(j_grid==4)then       
PARGUESS(5)=23000.d0

	 
        elseif(j_grid==5)then
           PARGUESS(5)= 3800.d0
            
        elseif(j_grid==6)then     
             PARGUESS(4)= 0.0023d0
                   
        elseif(j_grid==7)then
            PARGUESS(4)= 0.002d0
        
        elseif(j_grid==8)then
            PARGUESS(4)= 0.0015d0
         
        elseif(j_grid==9)then       
            PARGUESS(4)=2.77d0
            PARGUESS(11)=0.0015d0
             
        elseif(j_grid==10)then
            PARGUESS(4)=2.77d0
            PARGUESS(11)=0.002d0

        endif
!        aggagemax = 18
!        aggrowth = 0.0d0         
      
        !wagemult = 1.d0 
        
		call cpu_time( time1 )  
     
if(ID.eq.0)write(*,*)'call partner'
		call partner(parguess,targetst,numtargets)
		
		close(20)
		close(44)
		!close(45)
       
     
		call cpu_time( time2 )  
		write (10,*) 'one call takes ', time2-time1



    
enddo  !end loop over j_grid
enddo  !end loop over j_grid2

end subroutine calibrate

