!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


module assetgrid 
      use inputs
	  use params 
	  use wageproc 
	  use subrout
	  


use inputs

 
	  implicit none 
 
	  double precision, private :: const, deviate, devmen, experto, inimax,inipar, lower, & 
	  maxdummy, meandif, nconst, proport, upnew, workhigh, wage2,payrollm,earnmnet
 
	  integer, private :: i, ind, ind1, jl, jm, ju, p, t , x, xmin, xtob, xtonon 
	  contains  
 
	  subroutine bounds 
 
			!asset grid is now grid for cash excluding wage 
			
			!!LOWER BOUNDS
 
			mininc(1,nt+ret)	= 0.d0 
			 
			do t=nt+ret,1,-1 
			
			 if (t.le.nt) then 
			    do x=1,noexp
			 
				    if (borrowdum.eq.0) then  !borrowing is allowed
        !~                  wage2=xw(nw,t)*ryearsexp(expvalue(x,t))
        !~                  if (t.lt.nt) then 
        !~                    
        !~                      if(t.eq.1)then
        !~                        if(t.le.ntH)then
								!~	alow(x,t)= pxw(pnw,t) -payrolltax(pxw(pnw,t)) 
								!~else
								!~	alow(x,t)= pxpen(pnw)  !pxw(pnw,t) 
								!~endif
        !~                      else
					   !~          alow(x,t) = -max(mininc(max(x-1,1),t), mininc(x,t) + & 
			   		!~	            
			   		!~	             wage2*hoursfix-payrolltax(wage2*hoursfix)-fixed(t)) + minass 
    			 !~  			  endif        
        !~                  else 
					   !~       alow(x,t) = - max(mininc(1,t), mininc(1,t) + & 
			   		!~	    
			   		!~	          wage2*hoursfix-payrolltax(wage2*hoursfix)-fixed(t)) + minass
    			 !~  			         
        !~                  endif
          		    
          		   	
          		    
				    elseif (borrowdum.ge.1) then !no borrowing (note structure of prog has xa being 
											!cash, so this is not a point due to partner income
					    if(t.le.ntH)then
							alow(x,t)= pxw(pnw,t) -payrolltax(pxw(pnw,t)) 
						else
							alow(x,t)= pxpen(pnw)  !pxw(pnw,t) 
						endif
					

				    endif
				 
			    enddo  !do x
				
			
			 
			    do x=1,noexp
				    if (borrowdum.eq.0) then 
					    !if (t.ge.2) mininc(x,t-1)	= (- min(alowemp(x,t),alownon(x,t)) + pxw(pnw,t)*ptrxw(ptrneug))/detrr 
					 !~   if (t.ge.2) mininc(x,t-1)	= (- alow(x,t) + pxw(pnw,t)-payrolltax(pxw(pnw,t)) )/detrr 
                                                    
				    elseif (borrowdum.ge.1) then !no borrowing
					    if (t.ge.2) mininc(x,t-1) = 0.d0
				    endif
    				 
			    enddo
		
    		else   !t<=nt
    		
			    !!alow(1,t)       = pxw(pnw,nt) * ssi
			    
			  				
				alow(1,t)       =  pxpen(pnw)*survpen(1)  !pxw(pnw,nt)*survpen(1)
			
                mininc(1,t-1)   = 0.d0
                
            
    		
    		endif
 
			enddo 
			
			
			!!!UPPER BOUND
				 
            ind=(1-quarter)*60+quarter*70
            
			if (borrowdum.le.1) then !saving is unconstrained
			
			    wage2=xw(1,1)*ryearsexp(expvalue(noexp,1))
				
				!ahigh(1) = (xw(1,1)*expvalue(noexp,1)*hoursfix-fixed(1) + pxw(1,1))
				payrollm=payrolltax(pxw(1,1))
				earnmnet=pxw(1,1)-payrollm
				ahigh(1) = earnmnet
				ahigh2(1) = (wage2*hoursfix-payrolltax(wage2*hoursfix)-fixed(1) + ahigh(1)) 
				
				
				
				do t=2,nt
				
				wage2=xw(1,min(t,nt))*ryearsexp(expvalue(noexp,min(t,nt)))
                
				if(t.lt.ind)then
				
				
			    
                  !ahigh(t) = ahigh(t-1)*detrr + growth*(xw(1,t)*expvalue(noexp,t)*hoursfix-fixed(t) &
				!					+ pxw(1,t) )
				  
				  if(t.le.ntH)then
					payrollm=payrolltax(pxw(1,t))
					earnmnet=pxw(1,t)-payrollm
					ahigh(t) = ahigh2(t-1)*detrr + 0.5*earnmnet
				  else
					ahigh(t) = ahigh2(t-1)*detrr + 0.5*pxpen(1)  !pxw(1,min(t,nt))
				  endif 
				  ahigh2(t) = (0.5*(wage2*hoursfix-payrolltax(wage2*hoursfix)-fixed(min(t,nt))) + ahigh(t)) 
				    
		
				else
				    ahigh(t)=ahigh(t-1)
				    
			    endif		
				
				enddo

				do t=nt+1,nt+ret
					    if(quarter==0)then
					        ahigh(t) = ahigh(t-1)*0.90d0
					    else
					        ahigh(t) = ahigh(t-1)  !*0.98d0 
					    endif
					
				enddo
	

			elseif (borrowdum.eq.2) then !saving is constrained
				ahigh(1) = max(pxw(1,1), 1.d0)
				do t=2,nt
					ahigh(t) = max(pxw(1,t) , 1.d0)
				enddo

			endif
			
			


	  end subroutine bounds 
 
	  subroutine grid(xval,nodeas, asage) 
 
	  integer asage, nodeas, xval
 
	! extra points very close to bottom ("lown" points) 
	! then large cluster in reasonable range, spread geometrically 
	! then some at high asset levels (above "upper"),  
	! spread out more, where solution is more linear ("uppn" points)  
								 
			 !first do employed bit 

 			 workhigh = ahigh(asage) !max(alow(xval,asage)+0.1d0, min(asscut(nodeas,asage),ahigh(asage))) 
			if (workhigh.gt.1.d-1) then  
		     !xawork(1,nodeas, asage) = alowemp(xval,asage) 
		     xawork(1,nodeas, asage) = alow(xval,asage) 
		     xawork(2,nodeas, asage) = xawork(1,nodeas,asage) + 1.d-8 
			 xawork(3,nodeas,asage) = xawork(2,nodeas, asage) + 1.d-6 
		     xawork(4,nodeas,asage) = xawork(3,nodeas,asage) + 1.d-4 
		     xawork(5,nodeas,asage) = xawork(4,nodeas,asage) + 1.d-4 
		     xawork(6,nodeas,asage) = xawork(5,nodeas,asage) + 1.d-3 


			 lower = xawork(6,nodeas,asage) + (workhigh-xawork(6,nodeas,asage))*0.075d0

			 const = (lower - xawork(6,nodeas,asage))/dble(lown-6) 

			 do i=7,lown 
			   xawork(i,nodeas,asage) = xawork(6,nodeas,asage) + const*dble(i-6)  
		     enddo 
			 !const = (workhigh - lower)/dble(na-lown) 
			 !do i=lown+1,na 
			 !  xawork(i,nodeas,asage) = lower + const*dble(i-lown)  
			 !enddo		 

			!NEW COARSE PART
			upnew = xawork(lown,nodeas,asage) + (workhigh-xawork(lown,nodeas,asage))*0.25d0
			  
			 const = (upnew - lower)/dble(na-lown-uppn) 
			 do i=lown+1,na-uppn 
			   xawork(i,nodeas,asage) = lower + const*(i-lown)  
			 enddo	
			 const = (workhigh - upnew)/dble(uppn) 
			 
			 do i=na-uppn+1,na 
				  xawork(i,nodeas,asage) = upnew + const*(i-(na-uppn))  
			 enddo
			 
			 
			 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			 !const = (workhigh - xawork(6,nodeas,asage))/dble(na-6)
			 !do i=7,na
			 !  xawork(i,nodeas,asage) = xawork(6,nodeas,asage) + const*dble(i-6)  
		     !enddo 
			 
			 
			 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	 	
		 else 
		     xawork(1,nodeas, asage) = alow(xval,asage)   
			 const = (workhigh - xawork(1,nodeas,asage))/dble(na-1)
			 do i=2,na 
			   xawork(i,nodeas,asage) = xawork(i-1,nodeas,asage) + const  
		     enddo 
		  endif

!~if(ID.eq.0.and.nodeas.eq.1)then
!~	
!~	do i=1,na 
!~	write(6666,*)nodeas,asage,i,xawork(i,nodeas,asage)
!~    enddo
!~	endif
		   

	  end subroutine grid 
 
 
 !_________________________________________________________
 
	  subroutine gridnon(xval, nodeas,asage) 
 
	  integer asage, nodeas, nadum, lowndum, uppndum , xval
 
			nadum = na 
			lowndum = lown 
			uppndum = uppn 
			!maxdummy = max(ahigh(asage),asscut(nodeas,asage)+100.d0 )
			
			maxdummy = ahigh(asage)                             
			xanon(1,nodeas,asage) = min(max(alow(xval,asage),asscut(nodeas,asage) ),ahigh(asage))
			
			if (xanon(1,nodeas,asage).ge.maxdummy) maxdummy = xanon(1,nodeas,asage) + 5.d0
			!!!
			xanon(2,nodeas,asage) = xanon(1,nodeas,asage) + 1.d-3 
			xanon(3,nodeas,asage) = xanon(2,nodeas,asage) + 1.d-2 

			lower = xanon(3,nodeas,asage) + (maxdummy - xanon(3,nodeas,asage))*0.075d0


			 const = (lower - xanon(3,nodeas,asage))/dble(lowndum-3) 

			 do i=4,lowndum 
			   xanon(i,nodeas,asage) = xanon(3,nodeas,asage) + const*(i-3)  
		     enddo 

			upnew = xanon(lowndum,nodeas,asage) + (maxdummy - xanon(lowndum,nodeas,asage))*0.25d0
			  
			 const = (upnew - lower)/dble(nadum-lowndum-uppndum) 
			 do i=lowndum+1,nadum-uppndum 
			   xanon(i,nodeas,asage) = lower + const*(i-lowndum)  
			 enddo						    


			 const = (maxdummy- upnew)/dble(uppndum) 
			 do i=nadum-uppndum+1,nadum 
				  xanon(i,nodeas,asage) = upnew + const*(i-(nadum-uppndum))  
			 enddo	

		!if(ID.eq.0.and.nodeas.eq.1)write(*,*)'xanon',asage, xanon(1,1,asage), xanon(na,1,asage)
 
		end subroutine gridnon		  


!_________________________________________________________
 
	  subroutine gridret(xval, nodeas,asage) 
 
	  integer asage, nodeas, nadum, lowndum, uppndum , xval
 
			nadum = na 
			lowndum = lown 
			uppndum = uppn 
			!maxdummy = max(ahigh(asage),asscut(nodeas,asage)+100.d0 )
			
			maxdummy = ahigh(asage)                             
			!xaret(1,nodeas,asage) = min(max(alow(xval,asage),asscut(nodeas,asage) ),ahigh(asage))
			xaret(1,nodeas,asage) = alow(xval,asage)
			if (xaret(1,nodeas,asage).ge.maxdummy) maxdummy = xaret(1,nodeas,asage) + 5.d0
		
			xaret(2,nodeas,asage) = xaret(1,nodeas,asage) + 1.d-3 
			xaret(3,nodeas,asage) = xaret(2,nodeas,asage) + 1.d-2 

			lower = xaret(3,nodeas,asage) + (maxdummy - xaret(3,nodeas,asage))*0.075d0


			 const = (lower - xaret(3,nodeas,asage))/dble(lowndum-3) 

			 do i=4,lowndum 
			   xaret(i,nodeas,asage) = xaret(3,nodeas,asage) + const*(i-3)  
		     enddo 

			upnew = xaret(lowndum,nodeas,asage) + (maxdummy - xaret(lowndum,nodeas,asage))*0.25d0
			  
			 const = (upnew - lower)/dble(nadum-lowndum-uppndum) 
			 do i=lowndum+1,nadum-uppndum 
			   xaret(i,nodeas,asage) = lower + const*(i-lowndum)  
			 enddo						    


			 const = (maxdummy- upnew)/dble(uppndum) 
			 do i=nadum-uppndum+1,nadum 
				  xaret(i,nodeas,asage) = upnew + const*(i-(nadum-uppndum))  
			 enddo	

			!if(ID.eq.0.and.nodeas.eq.1)write(*,*)'xaret',asage, xanon(1,1,asage), xaret(na,1,asage)	 
 
		end subroutine gridret	      
 
end module assetgrid 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
