

clear matrix
clear
set more off
capture log close
set mem 200m

				
log using sampleCOMPARE.log,replace

			


u sampleR1.dta


collapse (mean) stat, by(age)

gen statr1=stat
drop stat
keep if age<66
sort age
save reform1.dta,replace

clear


u sampleR2.dta


collapse (mean) stat, by(age)

gen statr2=stat
drop stat
keep if age<66
sort age
save reform2.dta,replace

clear




u sample


collapse (mean) stat,by(age)
keep if age<66
sort age

sort age
merge age using reform2
drop _merge


sort age
merge age using reform1
drop _merge


*************************************************************************************************************************
*line stat age || line statr1 age || line statr2 age || line statr3 age, legend(order(1 "Benchmark" 2 "Reform 1" 3 "Reform 2" 4 "Reform 3")ring(0) position(5) cols(1)) ytitle("") xtitle("") ylab(0.2 0.4 0.6 0.8 1.0, labsize(3))   xlab(25 35 45 55 65, labsize(3))  graphregion( color(white )  )   saving(statREFORM, replace)


twoway (line stat age)|| (line statr1 age, lpattern(dot))  || (line statr2 age, lpattern(dot)), legend(order(1 "Benchmark" 2 "Reform 1" 3 "Reform 2" ) row(1)) ytitle("") xtitle("") ylab(0.2 0.4 0.6 0.8 1.0, labsize(3))   xlab(25 35 45 55 65, labsize(3))  graphregion( color(white )  )   saving(statREFORM, replace)

graph export profilesREFORM12.pdf,replace




*participation
gen     g=1 if age>=25 & age<=29
replace g=2 if age>=30 & age<=34
replace g=3 if age>=35 & age<=39
replace g=4 if age>=40 & age<=44
replace g=5 if age>=45 & age<=49
replace g=6 if age>=50 & age<=54
replace g=7 if age>=55 & age<=59
replace g=8 if age>=60 & age<=65


table g, c(mean stat mean statr1 mean statr2  )


collapse stat statr1 statr2 ,by(g)

gen r1=100*(statr1-stat)
gen r2=100*(statr2-stat)
*gen r3=statr3-stat

table g,c(mean r1 mean r2 )
log close

*fin


